<?php
	class MdlUser extends Mdl {
		function test($name, $pass, &$uid, &$fullname) {
			$sth = $this->pdo()->prepare('SELECT pass, id, fullname FROM user WHERE name = :name');
			$sth->execute(array('name' => $name));
			if ($select = $sth->fetch()) {
				$uid = $select['id'];
				$fullname = $select['fullname'];
				return password_verify($pass, $select['pass']);
			}
			return false;
		}
		
		function getAllUsers() {
			$sth = $this->pdo()->prepare('SELECT id, name, fullname FROM user');
			$sth->execute();
			return $sth->fetchAll();
		}
		
		function updateUser($name, $pass, $fullname = '') {
			$pass = password_hash($pass, PASSWORD_DEFAULT);
			$sth = $this->pdo()->prepare('INSERT INTO user (name, pass, fullname) VALUES (:name, :pass, :fullname) ON DUPLICATE KEY UPDATE pass = :pass, fullname = :fullname');
			return $sth->execute(array('name' => $name, 'pass' => $pass, 'fullname' => $fullname));
		}
		
		function deleteUser($name) {
			return $this->pdo()->prepare('DELETE FROM user WHERE name = :name')->execute(array('name' => $name));
		}
	}
?>
