<?php
	class URL {
		static function FullURL(...$pages) {
			$qs = '';
			if (is_array($last = array_pop($pages)))
				$qs = '?' . http_build_query($last);
			else
				$pages[] = $last;
			return $_SERVER['SCRIPT_NAME'] . '/' . implode('/', $pages) . '/' . $qs;
		}
		static function FullURLHTML(...$args) {
			return htmlspecialchars(self::FullURL(...$args));
		}
		static function DomainURL(...$pages) {
			return (@$_SERVER['HTTPS'] ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . self::FullURL(...$pages);
		}
		static function DomainURLHTML(...$args) {
			return htmlspecialchars(self::DomainURL(...$args));
		}
		static function Relative($base, $url) {
			if (preg_match('/^https?:/', $url))
				return $url;
			$comp = parse_url($base);
			if (substr($url, 0, 2) === '//')
				return $comp['scheme'] . ':' . $url;
			if (substr($url, 0, 1) === '/')
				return $comp['scheme'] . '://' . $comp['host'] . $url;
			return preg_replace('@/[^/]*$@', '', $base) . '/' . $url;
		}
		static function RelativeHTML(...$args) {
			return htmlspecialchars(self::Relative(...$args));
		}
	}
?>
