<?php
	abstract class Vue {
		/* array(<URL>, <Title>) */
		private $pages = array(array('Home', 'Home'),
							   array('Session', 'Sessions'),
							   array('Users', 'Users'));
		
		// To be implemented in child classes
		protected function authorize($post) { return true; }
		protected function handleGET() {}
		protected function handlePOST() {}
		abstract protected function render();
		
		final function handle() {
			$method = $_SERVER['REQUEST_METHOD'];
			if (!$this->authorize($method === 'POST'))
				return (new Vue403())->handle();
			if ($method === 'GET')
				$this->handleGET();
			if ($method === 'POST')
				$this->handlePOST();
			$this->render();
		}
		
		final protected function renderTitle($title, $menu = true) {
?>
<!doctype html>
<meta content=width=device-width name=viewport />
<link href=/style/sheet.css rel=stylesheet />
<title><?= htmlspecialchars($title) ?></title>
<?php if ($menu): ?>
<form method=post><table width=100%><tr>
	<td align=left>
		Welcome, <span class=user><?= htmlspecialchars(USERNAME . ' (' . USER . ')') ?></span>.
		<br />
<?php	foreach ($this->pages as list($page, $name)): ?>
		<a href="<?= URL::FullURLHTML(...(array)$page) ?>"><?= htmlspecialchars($name) ?></a>
<?php	endforeach; ?>
	</td>
	<td align=right nowrap>
		<button name=_logout>Logout</button>
	</td>
</tr></table></form>
<hr />
<?php endif; ?>
<h1><?= htmlspecialchars($title) ?></h1>
<?php
		}
	}
?>
